;
; Clone Ethernet & IP adress from EEPROM to prebuilded EEPROM packet
;
;extrn	NUMBER(flash_my_ether)
;extrn	NUMBER(flash_my_ip)
;extrn	NUMBER(flash_ip_gateway)
	.global	cloneEther
	.global	cloneIP
	.global	cloneGW

.nolist
.include "../include/param.inc"
.include "../include/8019.inc"
.list

	.equ	DPH1, 0x85
	.equ	DPL1, 0x84
	.equ	WMCON, 0x96
	.equ	DPS, 0b00000100
	.equ	EEMEN, 0b00001000
	.equ	EEMWE, 0b00010000

	.text
	.using	0

cloneEther:
	mov	DPH1,#HIGH(flash_my_ether)
	mov	DPL1,#LOW(flash_my_ether)
	mov	r1,#ETHER_ADDR_LEN
	sjmp	loadip
;
cloneIP:
	mov	DPH1,#HIGH(flash_my_ip)
	mov	DPL1,#LOW(flash_my_ip)
clone4:	mov	r1,#IP_ADDR_LEN
loadip:mov	WMCON,#(WATCHDOG | EEMEN | DPS);enable EEPROM & DPTR'
	movx	a,@dptr
	mov	R0,a
	inc	dptr
	mov	WMCON,#(WATCHDOG | EEMEN | EEMWE) ;enable R/W EEPROM
	movx	a,@dptr		;read eeprom
	xrl	a,R0
	jz	noip		;no need change, bypas write
	mov	a,R0
	movx	@dptr,a		;write
waitip:	movx	a,@dptr		;wait for end of write
	cjne	A,AR0,waitip
noip:	inc	dptr
	djnz	r1,loadip
	mov	WMCON,#WATCHDOG		;disable EEPROM & DPTR'
	ret
;
cloneGW:
	mov	DPH1,#HIGH(flash_ip_gateway)
	mov	DPL1,#LOW(flash_ip_gateway)
	sjmp	clone4
	;; END
