;
; Clone IP point adress from EEPROM to prebuilded EEPROM packet
;
;extrn	NUMBER(flash_ip_point)
;extrn	BIT(flagIPactive)
	.global	cloneIPpoint

.nolist
.include "../include/param.inc"
.include "../include/8019.inc"
.list

	.equ	DPH1, 0x85
	.equ	DPL1, 0x84
	.equ	WMCON, 0x96
	.equ	DPS, 0b00000100
	.equ	EEMEN, 0b00001000
	.equ	EEMWE, 0b00010000

	.text
	.using	0

cloneIPpoint:
	clr	flagIPactive
	mov	DPH1,#HIGH(flash_ip_point)
	mov	DPL1,#LOW(flash_ip_point)
	mov	r1,#IP_ADDR_LEN
loadipp:mov	WMCON,#(WATCHDOG | EEMEN | DPS)  ;enable EEPROM & DPTR'
	movx	a,@dptr
	mov	R0,a
	inc	dptr
	jz	nosetIPactive
	setb	flagIPactive
nosetIPactive:
	mov	WMCON,#(WATCHDOG | EEMEN | EEMWE) ;enable R/W EEPROM
	movx	a,@dptr		;read eeprom
	xrl	a,R0
	jz	noipp		;no need change, bypas write
	mov	a,R0
	movx	@dptr,a		;write
waitipp:movx	a,@dptr		;wait for end of write
	cjne	A,AR0,waitipp
noipp:	inc	dptr
	djnz	r1,loadipp
	mov	WMCON,#WATCHDOG		;disable EEPROM & DPTR'
	ret
	;; END
