;
; SPECIAL REGISTER
;
	.equ	DPH1,  0x85
	.equ	DPL1,  0x84
	.equ	WMCON, 0x96
	.equ	DPS,   0b00000100
	.equ	EEMEN, 0b00001000
	.equ	EEMWE, 0b00010000
;
.nolist
.include	"../include/param.inc"
.include	"../include/8019.inc"
.list
	.equ	CR, 0x0D
	.equ	LF, 0x0A

	.global	http
	.global	open_http
	.global	I2Cpresent
	.global	flagSecure

;	RSEG	CPU_BIT
;;***** http *****
	.bitcomm I2Cpresent, 1
	.bitcomm fastI2C, 1
	.bitcomm flagIFcgi, 1
	.bitcomm flagskipL, 1
	.bitcomm flagskipR, 1
	.bitcomm flagSecure, 1

;	RSEG	CPU_DATA
	.comm fileID, 2
	.comm workreg, 4 	;PI2X,... work register for convert const to string

;	RSEG	CPU_ROM
	.text
	.using	0
;*************************************************************
; http line parameters parser & exec
;*************************************************************
;
state80table:
	.equ	stateG0, 0
	sjmp	port80g0	;0 'G'
	sjmp	port80g1	;1 'E'
	sjmp	port80g2	;2 'T'
	sjmp	port80g3	;3 ' '
	.equ	stateS0, 3
	ljmp	port80s0	;4 compute checksum and wait
				;  for '/' or ' ' or '?'
;
http:

;Acknowledge all received data
;;  tx_eth_pkt.pkt.ip.ipdata.tcp.tcpheader.Ack =
;;    rcvSeq + data_len;
    	mov	r6,data_len
    	mov	r7,data_len+1
   	lcall	AckBytes

	setb	flagSecure	;enable secured CGI
;;  copy_r2s (buf, data_addr, sizeof(buf));	//and copy WWW request
getnextbuf:
	mov	r7,#buf
	mov	r4,data_addr
	mov	r5,data_addr+1
	mov	r3,#LOW(sizeofbuf)
      	lcall	short_r2_pr2s			;copy WWW request
	mov	R0,#buf-1
next80:	inc	R0
	mov	a,#bufend
	xrl	a,R0
	jz	getnextbuf
	mov	a,data_len
	jnz	long80data
	mov	a,data_len+1
	jz	_next80search
long80data:
	mov	a,@R0
	cjne	a,#CR,no80cr
_exeurl:ljmp	exeurl
_next80search:
	ljmp	next80search
no80cr:	cjne	a,#LF,no80lf
	sjmp	_exeurl
no80lf:	jz	_exeurl
;;  data_addr++;
	inc	data_addr+1	;LSB
	mov	a,data_addr+1
	jnz	noinchidaddr
	inc	data_addr	;MSB
noinchidaddr:
;; data_len--;
	dec	data_len+1	;LSB
	mov	a,data_len+1
	cjne	a,0xFF,nodecdlen
	dec	data_len	;MSB
nodecdlen:
	mov	a,state80
	add	a,acc		;sjmp = 2 byte
	add	a,#LOW(state80table)
	push	Acc		;push low addr
	mov	a,#0
	addc	a,#HIGH(state80table)
	push	Acc		;push high addr
	ret			;and Go!
;
;state 0 - wait for 'G'
port80g0:mov	a,@R0
	orl	a,#0x20		;G->g
	cjne	a,#'g',next80
	inc	state80		;state80 = 1
	sjmp	next80

;state 1 - wait for 'E'
port80g1:mov	a,@R0
	orl	a,#0x20		;E->e
	cjne	a,#'e',reset80
	inc	state80		;state80 = 2
	sjmp	next80
reset80:
	mov	state80,#stateG0
	sjmp	next80

;state 2 - wait for 'T'
port80g2:mov	a,@R0
	orl	a,#0x20		;T->t
	cjne	a,#'t',reset80
	inc	state80		;state80 = 3
	sjmp	next80

;state 3 - wait for ' '
port80g3:mov	a,@R0
	cjne	a,#' ',reset80
	inc	state80		;state80 = 4
	mov	fileID,#0
	mov	fileID+1,#0
	sjmp	next80

;state 4 - wait for '/' or ' ' or '?'
port80s0:mov	a,@R0
	cjne	a,#'/',nolom
	mov	fileID,#0
	mov	fileID+1,#0
	sjmp	next80
nolom:	cjne	a,#' ',nospc
	sjmp	exeurl
nospc:	cjne	a,#'?',url80
	sjmp	exeurl
url80:	add	a,fileID+1
	mov	fileID+1,a
	mov	a,fileID
	addc	a,#0
	mov	fileID,a
	ljmp	next80
;
next80search:
	setb	modeResend	;don't send FIN packet, wait for next packet
	ret
;
badmethod:
;;SendNotImplementedHeader
	lcall	send_string
	.ascii	"HTTP/1.1 501 Not Implemented"
	.byte	LF,LF,0
	RET
httpnotfound:
;;SendNotFoundHeader
	lcall	send_string
	.ascii	"HTTP/1.1 404 Not Found"
	.byte	LF,LF,0
	RET
cgi:
	ret
;
exeurl:	mov	a,state80
	anl	a,#0b11111100	;>3
	jz	badmethod
	mov	state80,#8	;binary mode
;
	lcall	searchfile	;r4	file type
				;dptr	file start
				;r2r3	file end
	jc	httpnotfound
;
	mov	a,r4
	anl	a,#0b11111000
	jnz	cgi
	push	ar2	;MSB file end
	push	ar3	;LSB file end
	push	dph	;MSB file start
	push	dpl	;LSB file start
	push	ar5	;filesystem ID
	mov	a,r4
	jz	_httpcont
;
;;SendHTTPheader
	push	acc	;file type
	lcall	send_string
	.ascii	"HTTP/1.1 200 OK"
	.byte	LF
	.asciz	"Content-type: "
	pop	acc	;file type
;
	cjne	a,#1,notext
;;SendTextHeader
	lcall	send_string
	.ascii	"text/html"
	.byte	LF,LF,0
	mov	state80,#0	;cgi mode
_httpcont:sjmp	httpcont
notext:	cjne	a,#2,noplain
;;SendPlainHeader
	lcall	send_string
	.ascii	"text/plain"
	.byte	LF,LF,0
	mov	state80,#0	;cgi mode
	sjmp	httpcont
noplain:cjne	a,#3,nojpeg
;;SendJPEGheader
	lcall	send_string
	.ascii	"image/jpeg"
	.byte	LF,LF,0
	sjmp	httpcont
nojpeg:	cjne	a,#4,nogif
;;SendGIFheader
	lcall	send_string
	.ascii	"image/gif"
	.byte	LF,LF,0
	sjmp	httpcont
nogif:	cjne	a,#5,nopng
;;SendPNGheader
	lcall	send_string
	.ascii	"image/png"
	.byte	LF,LF,0
	sjmp	httpcont
nopng:	cjne	a,#6,httpcont
;;SendAppHeader
	lcall	send_string
	.ascii	"application/octet-stream"
	.byte	LF,LF,0
;
httpcont:
	pop	Acc	;filesystem ID
	pop	dpl	;LSB file start
	pop	dph	;MSB file start
.if I2Cfilesystem
	jz	I2Cfiles
.endif
.if ROMfilesystem
	jb	B2B(ACC,0),ROMfiles
.endif
.if EEfilesystem
	jb	B2B(ACC,1),EEfiles
.endif
;!!! snad alespon jeden je zapnut, takze to v nem skonci
.if I2Cfilesystem
I2Cfiles:sjmp	I2Ccur
I2Clop:	push	ar2	;MSB
	push	ar3	;LSB
I2Ccur:	push	dph
	push	dpl
	jb	fastI2C, rch
	lcall	read_random
	setb	fastI2C
	sjmp	rrh
rch:	lcall	read_current
rrh:	lcall	httpchar
	pop	dpl	;LSB file start
	pop	dph	;MSB file start
	pop	ar3	;LSB file end
	pop	ar2	;MSB file end
	inc	dptr
	mov	a,dph
	cjne	a,ar2,I2Clop
	mov	a,dpl
	cjne	a,ar3,I2Clop
	ret
.endif
.if ROMfilesystem
ROMfiles:sjmp	ROMcur
;
ROMlop:	push	ar2	;MSB
	push	ar3	;LSB
ROMcur:	push	dph
	push	dpl
	clr	a
	movc	a,@a+dptr
	lcall	httpchar
	pop	dpl	;LSB file start
	pop	dph	;MSB file start
	pop	ar3	;LSB file end
	pop	ar2	;MSB file end
	inc	dptr
	mov	a,dph
	cjne	a,ar2,ROMlop
	mov	a,dpl
	cjne	a,ar3,ROMlop
	ret
.endif
.if EEfilesystem
EEfiles:sjmp	EEcur
;
EElop:	push	ar2	;MSB
	push	ar3	;LSB
EEcur:	push	dph
	push	dpl
	mov	WMCON,#(WATCHDOG | EEMEN) ;enable EEPROM
	movx	a,@dptr
	mov	WMCON,#WATCHDOG	;disable EEPROM
	lcall	httpchar
	pop	dpl	;LSB file start
	pop	dph	;MSB file start
	pop	ar3	;LSB file end
	pop	ar2	;MSB file end
	inc	dptr
	mov	a,dph
	cjne	a,ar2,EElop
	mov	a,dpl
	cjne	a,ar3,EElop
	ret
.endif
;
searchfile:
.if I2Cfilesystem
	jnb	I2Cpresent,NoScanI2C
	clr	fastI2C
	mov	dptr,#4		;offset of "file directory" in I2C EEPROM
I2Cdir:	lcall	read_random
	inc	a	;end of directory ?
	jz	I2Ceof
	dec	a
	xrl	a,fileID
	jnz	nextI2Cdir
	lcall	read_current
	xrl	a,fileID+1
	jnz	nextI2Cdir
	lcall	read_current
	mov	r4,a	;file type
	lcall	read_current
			;reserved
	lcall	read_current
	mov	dph,a	;MSB file start
	lcall	read_current
	mov	dpl,a	;LSB file start
	lcall	read_current
	mov	r2,a	;MSB file end
	lcall	read_current
	mov	r3,a	;LSB file end
	mov	r5,#0	;I2C filesystem
	clr	c	;O.K.
	ret
nextI2Cdir:
	mov	a,dpl
	add	a,#8
	mov	dpl,a
	jnc	I2Cdir
	inc	dph
	sjmp	I2Cdir
I2Ceof:
NoScanI2C:
.endif
.if ROMfilesystem
	mov	dptr,#filedir	;offset of "file directory" in ROM
ROMdir:	clr	a
	movc	a,@a+dptr
	inc	a	;end of directory ?
	jz	ROMeof
	dec	a
	xrl	a,fileID
	jnz	nextROMdir
	mov	a,#1
	movc	a,@a+dptr
	xrl	a,fileID+1
	jnz	nextROMdir
	mov	a,#2
	movc	a,@a+dptr
	mov	r4,a	;file type
	mov	a,#6
	movc	a,@a+dptr
	mov	r2,a	;MSB file end
	mov	a,#7
	movc	a,@a+dptr
	mov	r3,a	;LSB file end
	mov	a,#4
	movc	a,@a+dptr
	push	acc	;MSB file start
	mov	a,#5
	movc	a,@a+dptr
	mov	dpl,a	;LSB file start
	pop	dph	;MSB file start
	mov	r5,#1	;ROM filesystem
	clr	c	;O.K.
	ret
nextROMdir:
	mov	a,dpl
	add	a,#8
	mov	dpl,a
	jnc	ROMdir
	inc	dph
	sjmp	ROMdir
ROMeof:
.endif
.if EEfilesystem
	mov	dptr,#fileee	;offset of "file directory" in EEPROM
	mov	WMCON,#(WATCHDOG | EEMEN) ;enable EEPROM
EEdir:	clr	a
	movx	a,@dptr
	inc	a	;end of directory ?
	jz	EEeof
	dec	a
	xrl	a,fileID
	jnz	nextEEdir
	inc	dptr	;1
	movx	a,@dptr
	xrl	a,fileID+1
	jnz	nextEEdir7
	inc	dptr	;2
	movx	a,@dptr
	mov	r4,a	;file type
	inc	dptr	;3
	inc	dptr	;4
	movx	a,@dptr
	push	acc	;MSB file start
	inc	dptr	;5
	movx	a,@dptr
	push	acc	;LSB file start
	inc	dptr	;6
	movx	a,@dptr
	mov	r2,a	;MSB file end
	inc	dptr	;7
	movx	a,@dptr
	mov	r3,a	;LSB file end
	pop	dpl	;LSB file start
	pop	dph	;MSB file start
	clr	c	;O.K.
	mov	WMCON,#WATCHDOG	;disable EEPROM
	mov	r5,#2	;EEPROM filesystem
	ret
nextEEdir:
	inc	dptr
nextEEdir7:
	mov	a,dpl
	add	a,#7
	mov	dpl,a
	jnc	EEdir
	inc	dph
	sjmp	EEdir
EEeof:
	mov	WMCON,#WATCHDOG	;disable EEPROM
.endif
	setb	c	;file not found
	ret
;
httpchar:
	mov	r2,a
	mov	a,state80
	jz	nonamescan
	cjne	a,#8,gohttpchar
nocgistart:
	mov	a,r2
	ljmp	sendchar
nonamescan:
	jnb	flagskipL,noscanL
	cjne	R2,#'{',noLeft0Br
	clr	flagskipL
	setb	flagskipR
	ret
noLeft0Br:
	cjne	R2,#'}',noRight0Br
	clr	flagskipL	;normal
	clr	flagskipR
noRight0Br:
	ret
noscanL:jnb	flagskipR,noscanR
	cjne	R2,#'{',noLeft1Br
	setb	flagskipL	;no echo
	clr	flagskipR
	ret
noLeft1Br:
	cjne	R2,#'}',noRight1Br
	clr	flagskipL	;normal
	clr	flagskipR
	ret
noRight1Br:
	mov	a,r2
	ljmp	sendchar
noscanR:cjne	R2,#0x27,nocgistart ;''''
	clr	flagIFcgi
	inc	state80		;1
	ret
;
gohttpchar:
	add	a,acc		;sjmp = 2 byte
	add	a,#LOW(http80table-2)
	push	Acc		;push low addr
	mov	a,#0
	addc	a,#HIGH(http80table-2)
	push	Acc		;push high addr
	mov	a,r2
	ret			;and Go!
;
http80table:
	sjmp	testdouble	;1
	sjmp	scanpoint	;2
	sjmp	scanc		;3
	sjmp	scang		;4
	sjmp	scani		;5
	sjmp	scansp		;6
	sjmp	getpar		;7
;
testdouble:
	cjne	a,#0x27,nodouble ;''''
resetstate80:
	mov	state80,#0
	ljmp	sendchar
nodouble:cjne	a,#'?',noifcgi
	setb	flagIFcgi
	ret
noifcgi:inc	state80		;2
	mov	fileID,#0
	mov	fileID+1,a
	ret
;
scanpoint:
	cjne	a,#'/',nosubdir
	mov	fileID,#0
	mov	fileID+1,#0
	ret
nosubdir:cjne	a,#'.',nopoint
goaddst:inc	state80		;3
nopoint:add	a,fileID+1
	mov	fileID+1,a
	mov	a,fileID
	addc	a,#0
	mov	fileID,a
	ret
;
scanc:	cjne	a,#'c',resetstate80
	sjmp	goaddst		;4
;
scang:	cjne	a,#'g',resetstate80
	sjmp	goaddst		;5
;
scansp:	cjne	a,#'?',scanqv
	inc	state80		;7
	ret
;
scanqv:	cjne	a,#0x27,resetstate80 ;''''
	mov	state80,#0
execgi:
	lcall	searchfile	;r4	file type
				;dptr	file start
				;r2r3	file end
	jc	cginotfound
	mov	workreg,dph
	mov	workreg+1,dpl
	PUSH	pcodeMSB
	PUSH	pcodeLSB
	lcall	pcode
      	.pcode	pcall @workreg
	.byte	0
	POP	pcodeLSB
	POP	pcodeMSB
cginotfound:
	mov	state80,#0
	jbc	flagIFcgi,testCGIflags
	clr	flagskipL
	clr	flagskipR
;end of exe cgi
	ret
testCGIflags:
	mov	C,zflag
	mov	flagskipL,C
	cpl	C
	mov	flagskipR,C
	ret
;
scani:	cjne	a,#'i',resetstate80
	sjmp	goaddst		;6
;
getpar:	mov	state80,a
	sjmp	execgi
;
open_http:
	mov	state80,#0	; reset url scanner
	ret
	;; END
