; RTL8019 & 8052 Packet driver (c)Copyright 2000, Radek Benedikt
;	benedikt@lphard.cz, http://benedikt.lphard.cz

; History: 1.0b -- Radek Benedikt 04-Sep-2001
;  binutils version 
; History: 1.01 -- Radek Benedikt 31-Oct-2000
;  without callback ProcessEthPacket
; History: 1.00 -- Radek Benedikt 26-Feb-2000
;  initial version
;*************************************************************
;***		PROJECT WWW8052  http://8052.lphard.cz	    **
;*************************************************************

;   This program is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, version 2.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the Free Software
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;   Tento program je volne programove vybaveni; muzete jej sirit a
;   modifikovat podle ustanoveni Obecne verejne licence GNU, vydavane Free
;   Software Foundation, verze 2
;
;   Tento program je rozsirovan v nadeji, ze bude uzitecny, avsak BEZ
;   JAKEKOLI ZARUKY; neposkytuji se ani odvozene zaruky PRODEJNOSTI anebo
;   VHODNOSTI PRO URCITY UCEL.
;   Dalsi podrobnosti hledejte v Obecne verejne licenci GNU.
;
;   Kopii Obecne verejne licence GNU jste mel obdrzet spolu s timto
;   programem; pokud se tak nestalo, napiste o ni Free Software Foundation,
;   Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
	.global	network_init
	.global	InitRTL8019
	.global	tx_wait
	.global	xmit_frame
	.global	send_pkt
	.global	rcv_pkt
	.global	DMARead
	.global	DMAWrite
	.global	icall_load
	.global	icall_save
	.global	plongpause

	.global	eth_state1
	.global	eth_state2
	.global	flagResend
	.global	next_packet
	.global	curr_recv
	.global	curpage

.nolist
.include	"../include/param.inc"
.include	"../include/8019.inc"
.list
;
	.equ	endport, 0x40
	.equ	portind, 0x20
;
	.equ	DPH1,  0x85
	.equ	DPL1,  0x84
	.equ	WMCON, 0x96
	.equ	DPS,   0b00000100
	.equ	EEMEN, 0b00001000
	.equ	EEMWE, 0b00010000

	.equ	my_ether, buf		;6 my ethernet address

	.macro	BEGINPORTDATA
	lcall	send_port
	.endm
;
	.macro	PORTDATA prtaddr, prtdata
	.byte	\prtaddr, \prtdata
	.endm
;
	.macro	ENDPORTDATA
	.byte	endport
	.endm
;
	.macro	ISAREAD
.if MOVXMODE
	MOVX	A,@R0
.else
	MOV	P0,#0xFF
	CLR	P3.7
	NOP
	MOV	A,P0
	SETB	P3.7
.endif
	.endm
;
	.macro	ISAWRITE
.if MOVXMODE
	MOVX	@R0,A
.else
	MOV	P0,A
	CLR	P3.6
	NOP
	SETB	P3.6
.endif
	.endm
;
	.macro	ISAIN IO_ADDR
	MOV	ADDRPORT,#(\IO_ADDR+I2CBUS)
.if MOVXMODE
	MOVX	A,@R0
.else
	MOV	P0,#0xFF
	CLR	P3.7
	NOP
	MOV	A,P0
	SETB	P3.7
.endif
	.endm
;
	.macro	ISAOUTA IO_ADDR
	MOV	ADDRPORT,#(\IO_ADDR+I2CBUS)
.if MOVXMODE
	MOVX	@R0,A
.else
	MOV	P0,A
	CLR	P3.6
	NOP
	SETB	P3.6
.endif
	.endm
;
	.macro	ISAOUT IO_ADDR, IO_DATA
.if MOVXMODE
	MOV	ADDRPORT,#(\IO_ADDR+I2CBUS)
	MOV	A,\IO_DATA
	MOVX	@R0,A
.else
	MOV	ADDRPORT,#(\IO_ADDR+I2CBUS)
	MOV	P0,IO_DATA
	CLR	P3.6
	NOP
	SETB	P3.6
.endif
	.endm
;
	.bitcomm eth_state1, 1
	.bitcomm eth_state2, 1
	.bitcomm flagResend, 1
;
	.comm	next_packet, 1	;pointer to next packet in Rx ring
	.comm	curr_recv, 1	;pointer to current packet in Rx ring
	.comm	curpage, 1	;current page of rcv ring
;
;*************************************************************

	.text
	.using 0

;*************************************************************
Reset_ISA:
	SETB	RESETBIT	;Reset ISA bus
	lcall   waitbus
	CLR	RESETBIT	;End of Reset ISA bus
	sjmp	waitbus
;
waitbus:
	PUSH    AR1
	PUSH    AR0
	MOV	R0,#0
waitbus1:
	MOV	R1,#0
waitbus2:
	DJNZ	R1,waitbus2
	DJNZ	R0,waitbus1
	POP     AR0
	POP     AR1
	RET
;*************************************************************
;DMA Read
;input:	R2R3	Remote Byte Count
;	R4R5	Remote Start Address Register
;	DPTR	Pointer to Procedure
DMARead:
	BEGINPORTDATA
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA+EN_START
				;Remote DMA, Start the chip, clear reset
;Set Remote byte count
;input:	R2R3	Byte Count
	.using	0
	PORTDATA	EN0_RCNTHI+portind,AR2	;MSB Remote byte count reg
	.using	0
	PORTDATA	EN0_RCNTLO+portind,AR3	;LSB Remote byte count reg
;Set Remote Start Address
;input:	R4R5
	.using	0
	PORTDATA	EN0_RSARHI+portind,AR4	;MSB Remote start address reg
	.using	0
	PORTDATA	EN0_RSARLO+portind,AR5	;LSB Remote start address reg
	.using	0
	PORTDATA	EN_CMD, EN_PAGE0+EN_RREAD+EN_START
				;Remote Read, Start the chip, clear reset
	ENDPORTDATA
DMAReadLoop:
	MOV	A,R3
	JNZ	DMAReadLoop1
	MOV	A,R2
	JZ	DMAReadEnd
DMAReadLoop1:
	MOV	ADDRPORT,#EN_DATA+I2CBUS
	ISAREAD
	MOV	R7,A		;save data from NIC to R7
	lcall	ICALL		;call save/compare...
	;dec R2R3 Remote Byte Count
	XCH	A,R3	;Exchange A for R3
	DEC	A	;Decrement A (which is R3)
	CJNE	A,#0xFF,r_dec_R23 ;If A (R3) is not #0FFh, continue normally
	DEC	R2	;If A=FFh, we need to decrement R2
r_dec_R23:
	XCH	A,R3	;Exchange A for R3 (thus saving R3 and restoring A)
	SJMP	DMAReadLoop
DMAReadEnd:
	RET
;
;*************************************************************
ICALL:	CLR	A
	JMP	@A+DPTR
;
;*************************************************************
icall_saveskip:
	MOV	A,R3
	JB	Acc.0,proc0ret	; skip
	MOV	A,R7
	MOV	@R1,A		; save
	INC	R1
proc0ret:
	RET
;
icall_save:
	MOV	A,R7
	MOV	@R1,A
	INC	R1
	RET
;*************************************************************
;DMA Write
;input:	R2R3	Remote Byte Count
;	R4R5	Remote Start Address Register
;	DPTR	Pointer to Procedure
DMAWrite:
	BEGINPORTDATA
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA+EN_START
				;Remote DMA, Start the chip, clear reset
	PORTDATA	EN0_TCNTHI+portind,AR2	;High byte of tx byte count
	PORTDATA	EN0_TCNTLO+portind,AR3	;Low  byte of tx byte count
;Set Remote byte count
;input:	R2R3	Byte Count
	PORTDATA	EN0_RCNTHI+portind,AR2	;MSB Remote byte count reg
	PORTDATA	EN0_RCNTLO+portind,AR3	;LSB Remote byte count reg
;Set Remote Start Address
;input:	R4R5
	PORTDATA	EN0_RSARHI+portind,AR4	;MSB Remote start address reg
	PORTDATA	EN0_RSARLO+portind,AR5	;LSB Remote start address reg
	PORTDATA	EN_CMD, EN_PAGE0+EN_RWRITE+EN_START
				;Remote Write, Start the chip, clear reset
	ENDPORTDATA
DMAWriteLoop:
	MOV	A,R3
	JNZ	DMAWriteLoop1
	MOV	A,R2
	JZ	DMAWriteEnd
DMAWriteLoop1:
	lcall	ICALL		;call save...
	MOV	ADDRPORT,#EN_DATA+I2CBUS
	ISAWRITE
	;dec R2R3 Remote Byte Count
	XCH	A,R3	;Exchange A for R3
	DEC	A	;Decrement A (which is R3)
	CJNE	A,#0xFF,w_dec_R23 ;If A (R3) is not #0FFh, continue normally
	DEC	R2	;If A=FFh, we need to decrement R2
w_dec_R23:
	XCH	A,R3	;Exchange A for R3 (thus saving R3 and restoring A)
	SJMP	DMAWriteLoop
DMAWriteEnd:
	RET
;
;*************************************************************
icall_load:
	MOV	A,@R1
	INC	R1
	RET
;
;*************************************************************
tx_wait:
	MOV	DPTR,#-40982	;max coll time = 1024*7 Ethernet slot units (51.2us)
tx_wait1:
	ISAIN	EN_CMD
	JB	BIT_TRANS,tx_wait0
	INC	DPTR
	MOV	A,DPH
	ORL	A,DPL
	JNZ	tx_wait1
.if TESTMODE
	lcall	out_string	;Transmit, with error
	db	CR,LF,'Timeout Xmit error',0
;; set errors flag...
.endif
tx_wait0:
	ret
;*************************************************************
; *** XMIT_FRAME *** transmit frame
; xmit_frame	length
;	R6R7		;Transmit Byte Count
xmit_frame:
send_pkt:
	ISAIN	EN_CMD
	JNB	BIT_TRANS,no_tx_wait
	LCALL	tx_wait
	SJMP	tx_idle0
no_tx_wait:
; Check for recent TX completions in the interrupt status register
	ISAIN	EN0_ISR		; Interrupt status reg
.if TESTMODE
	MOV	R2,A		; save Interrupt status reg
.endif
	ANL	A,#ENISR_TX_ERR+ENISR_TX ; Pending Tx interrupts?
	JZ	tx_idle		; No, Go on new Tx
.if TESTMODE
	JNB	BITISR_TX_ERR, XmitFrameNoErr
	lcall	out_string	; Transmit, with error
	db	CR,LF,'Xmit error: ',0
	MOV	A,R2
	lcall   out_hexb	; print hex from Acc
;; set errors flag...
XmitFrameNoErr:
.endif
tx_idle0:
	ISAIN	EN0_TSR		; Read Transmit status reg
;; save transmit status...
; Acknowledge the TX interrupt
	ISAOUT	EN0_ISR, #ENISR_TX_ERR+ENISR_TX ; Interrupt status reg
				; Set Transmitter Interrupt, with/no error
tx_idle:
	MOV	A,R7
	ADD	A,#LOW(-GIANT-1)
	MOV	A,R6
	ADD	A,#HIGH(-GIANT-1)
	JNC	XmitNoGiant
.if TESTMODE
	JNB	BITISR_TX_ERR, XmitFrameNoErr
	lcall	out_string	; Transmit, with error
	db	CR,LF,'Giant Xmit error: ',0
	MOV	A,R6
	lcall   out_hexb	; print hex from Acc
	MOV	A,R7
	lcall   out_hexb	; print hex from Acc
.endif
;; set errors flag...
	RET
XmitNoGiant:
	MOV	A,R6		; Is the frame long enought ?
	JNZ	XmitNoRunt
	MOV	A,R7
	ADD	A,#-RUNT
	JC	XmitNoRunt
;;	MOV	R6,#HIGH(RUNT)	; Stretch frame to minimum allowed
	MOV	R7,#LOW(RUNT)
XmitNoRunt:
	BEGINPORTDATA
	.using	0
	PORTDATA	EN0_TCNTHI+portind,AR6	; High byte of tx byte count
	.using	0
	PORTDATA	EN0_TCNTLO+portind,AR7	; Low  byte of tx byte count
	PORTDATA	EN0_TPSR+portind,stackOffset ; Transmit starting page
				; First page of TX buffer
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA+EN_TRANS+EN_START
				; Remote DMA, Transmit a frame,
				; Start the chip, clear reset
	ENDPORTDATA
	RET
;*************************************************************
ResetRTL8019:
	ISAIN	EN_RESET	; Reset Port (for all pages)
	lcall   longpause
	ISAOUTA	EN_RESET	; Reset Port (for all pages)
	ISAOUT	EN_CMD, #EN_PAGE0+EN_NODMA+EN_STOP
				; Remote DMA, Stop and reset the chip
	sjmp	longpause
;*************************************************************
;Read Station Address PROM (SAPROM)
;get_board_data:
;	ISAOUT	EN0_DCFG, #ENDCFG_FT10+ENDCFG_BMS+ENDCFG_WTS
;				; fifo treshold, Normal operation,
;				; word/byte transfer mode selection
;	mov	R2,#HIGH(2*ETHER_ADDR_LEN)	; R2R3 Byte Count
;	mov	R3,#LOW(2*ETHER_ADDR_LEN)
;	MOV	R4,#0		; R4R5 Remote Start Address
;	MOV	R5,#0
;	MOV	R1,#my_ether	; R1 store pointer
;	MOV	DPTR,#icall_saveskip; pointer to procedure BYTE(@R1) save/skip
;	sjmp	DMARead
;
;*************************************************************
network_init:
	LCALL   Reset_ISA
	;lcall	InitRTL8019
	;RET
InitRTL8019:
   	lcall	ResetRTL8019
;
	mov	dptr,#flash_my_ether
	mov	r0,#my_ether
	mov	r1,#ETHER_ADDR_LEN
;
	mov	WMCON,#(WATCHDOG | EEMEN)	;enable EEPROM
;
initaddr:
	movx	a,@dptr
	mov	@r0,a
	inc	dptr
	inc	r0
	djnz	r1,initaddr
;
	mov	WMCON,#WATCHDOG		;disable EEPROM
;
;Set Remote byte count
	BEGINPORTDATA
	PORTDATA	EN_CMD, EN_PAGE3+EN_NODMA ;Remote DMA
	PORTDATA	EN3_9346CR, 0xC0
	PORTDATA	EN1_CONFIG3, 0x38
	PORTDATA	EN3_9346CR,  0
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA ;Remote DMA
	PORTDATA	EN0_RCNTHI,0	;MSB Remote byte count reg
	PORTDATA	EN0_RCNTLO,0	;LSB Remote byte count reg
	PORTDATA	EN0_RXCR, ENRXCR_MON	;RX configuration reg
				;Monitor mode (no packets rcvd)
	PORTDATA	EN0_TXCR, ENTXCR_LOOP	;TX configuration reg
				;set internal loopback mode
;	ENDPORTDATA
;   	lcall   get_board_data
;	BEGINPORTDATA
	PORTDATA	EN0_DCFG, ENDCFG_FT10+ENDCFG_BMS+ENDCFG_WTS
				; fifo treshold, Normal operation,
				; word/byte transfer mode selection
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA ;Remote DMA
	PORTDATA	EN0_STARTPG, RX_START_PG ;Starting page of ring buffer
				;First page of RX Ring
	PORTDATA	EN0_BOUNDARY, RX_START_PG ;Boundary page of ring buffer
	PORTDATA	EN0_STOPPG,NE_STOP_PG	;Ending page +1 of ring buffer
				;End Page = Last page + 1 of RX Ring
	PORTDATA	EN0_ISR, -1	;Interrupt status reg
	PORTDATA	EN0_IMR, 0	;Interrupt mask reg = Disable All Interrupt
	PORTDATA	EN_CMD, EN_PAGE1+EN_NODMA ;Page 1, Remote DMA
	PORTDATA	EN1_PHYS+portind+0,my_ether+0;This board's physical enet addr
	PORTDATA	EN1_PHYS+portind+1,my_ether+1
	PORTDATA	EN1_PHYS+portind+2,my_ether+2
	PORTDATA	EN1_PHYS+portind+3,my_ether+3
	PORTDATA	EN1_PHYS+portind+4,my_ether+4
	PORTDATA	EN1_PHYS+portind+5,my_ether+5
	PORTDATA	EN_CMD, EN_PAGE1+EN_NODMA+EN_STOP ;Page 1,
				;Remote DMA, Stop and reset the chip
	PORTDATA	EN1_MULT+0,0xFF	;Multicast filter mask array (8 bytes)
	PORTDATA	EN1_MULT+1,0xFF
	PORTDATA	EN1_MULT+2,0xFF
	PORTDATA	EN1_MULT+3,0xFF
	PORTDATA	EN1_MULT+4,0xFF
	PORTDATA	EN1_MULT+5,0xFF
	PORTDATA	EN1_MULT+6,0xFF
	PORTDATA	EN1_MULT+7,0xFF
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA+EN_START
				;Remote DMA, Start the chip, clear reset
	PORTDATA	EN_CMD, EN_PAGE1+EN_NODMA+EN_STOP ;Page 1,
				;Remote DMA, Stop and reset the chip
	PORTDATA	EN1_CURPAG, RX_CURR_PG	;Current memory page = RX_CURR_PG
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA+EN_START
				;Remote DMA, Start the chip, clear reset
	PORTDATA	EN0_TXCR, 0	;TX configuration reg = Normal Operation
	PORTDATA	EN0_RXCR, ENRXCR_BCST	;RX configuration reg =
					; Accept broadcasts
	PORTDATA	EN0_ISR, -1	;Clear the pending Interrupt /* sichr */
	ENDPORTDATA
;
	MOV	next_packet,#RX_CURR_PG
;	JNB	flagRxEnable,NoRxEnable
;	ISAOUT	EN0_RXCR, #ENRXCR_BCST	;RX configuration reg =
;				; Accept broadcasts
;NoRxEnable:
;	ISAOUT	EN0_ISR, #-1	;Clear the pending Interrupt /* sichr */
	RET
;*************************************************************
;;Wait a full Tx time (1.2 ms) + some guard time, NS says 1.6 ms total.
plongpause:
longpause:
	PUSH	ACC
	PUSH    DPL
	PUSH    DPH
	MOV	DPTR,#-326
longpause_l:
	INC	DPTR
	MOV	A,DPL
	ORL	A,DPH
	JNZ	longpause_l
	POP     DPH
	POP     DPL
	POP	ACC
	RET
;*************************************************************
ReadPacketHeader:
	mov	R2,#HIGH(SIZE_OF_8019_HDR+SIZE_OF_ETH_PKT_HDR)
	mov	R3,#LOW(SIZE_OF_8019_HDR+SIZE_OF_ETH_PKT_HDR) ;R2R3 Byte Count
;	MOV	R4,#0		;R4R5 Remote Start Address
	MOV	R5,#0
	MOV	R1,#rcv_hdr	;R1 store pointer
	MOV	DPTR,#icall_save;pointer to procedure BYTE(@R1) save
	ljmp	DMARead
;*************************************************************
rcv_pkt:
	clr	rx_eth_bit
	jbc	eth_state1, rcv_ovr_ok
	jbc	eth_state2, _eth2state
	ISAIN	EN0_ISR		; Get pending interrupts
	JNZ	ISRtestOverrun
	RET			; Ret if none
_eth2state:	ljmp	eth2state
ISRtestOverrun:
						; Was there an overrun ?
	JB	BITISR_OVER,recv_overrun	; Go if so
	ljmp	recv_no_overrun			; Go if not
;*************************
;***     RxOverrun     ***
;*************************
recv_overrun:
	ISAIN	EN_CMD		; read Chip's command register
	PUSH	Acc		; and save it
;; Stop the NIC
	ISAOUT	EN_CMD, #EN_PAGE0+EN_NODMA+EN_STOP
				; Remote DMA, Stop and reset the chip
;; Wait 1.6ms for the NIC to stop transmitting or receiving a packet. National
;; says monitoring the ISR RST bit is not reliable, so a wait of the maximum
;; packet time (1.2ms) plus some padding is required.
	lcall   longpause
;; Reset RBCR[01] back to zero as per magic incantation.
	BEGINPORTDATA
	PORTDATA	EN0_RCNTHI,0	; MSB Remote byte count reg
	PORTDATA	EN0_RCNTLO,0	; LSB Remote byte count reg
	ENDPORTDATA
;; check the saved state of the EN_TRANS bit in the command register
	CLR	flagResend
	POP	Acc		; pop Chip's command register
	JNB	BIT_TRANS,rcv_ovr_loopback
;; Transmitter was running, see if it finished or died
	ISAIN	EN0_ISR		; Get pending interrupts
	ANL	A,#ENISR_TX_ERR+ENISR_TX ; Did the transmitter finish?
	JNZ	rcv_ovr_loopback	; one will be set if TX finished
; Transmitter did not complete, remember to resend the packet later.
	CLR	flagResend
rcv_ovr_loopback:
;; Have to enter loopback mode and then restart the NIC before you are
;; allowed to slurp packets up off the ring
	BEGINPORTDATA
	PORTDATA	EN0_TXCR,ENTXCR_LOOP ; set internal loopback mode
	PORTDATA	EN_CMD, EN_PAGE0+EN_NODMA+EN_START
				; Start the chip running again
;; Verify that there is really a packet to receive by fetching the current
;; page pointer and comparing it to the next packet pointer.
	PORTDATA	EN_CMD, EN_PAGE1+EN_NODMA	; Set Page 1
	ENDPORTDATA
	ISAIN	EN1_CURPAG	; Current memory page
;;	ISAOUTA	EN1_CURPAG	; Rewrite Current memory page to fix SMC bug
	MOV     R4,A
	ISAOUT	EN_CMD, #EN_PAGE0+EN_NODMA	; Page 1, Remote DMA
	MOV	A,next_packet
	XRL	A,R4		; Check if buffer empty
	JNZ	rcv_ovr_rx_one	; O.K. get the NIC header
; NO PACKET IN THE RING AFTER AN OVW INTERRUPT??? Can this ever happen?
; YES! if overrun happend between a receive interrupt and the when the
; current page register is read at the start of recv_frame.
	sjmp	rcv_ovr_empty	; Current Page == next_packet
rcv_ovr_rx_one:
;	MOV	R5,#0		; R4R5 Remote Start Address Register
	.using 0
	PUSH	AR4
	lcall   ReadPacketHeader
	POP	AR4
	MOV	A,rcv_hdr	; Get the buffer status byte
	;Received a good packet ?
	JNB	BITRSR_RXOK, rcv_ovr_ng  ; No, received debris
; EVEN if the NIC header status is OK, I have seen garbaged NIC headers, so
; it doesn't hurt to range check the next packet pointer here.
	MOV	A,rcv_hdr_nxt_pg	; pointer to next packet
	CJNE	A,#RX_START_PG,.+3	;; First page of RX Ring
	JC	rcv_ovr_ng	;; < RX_START_PG
				;;invalid pointer, Bellow around the bottom
	CJNE	A,#NE_STOP_PG,.+3;;Last page + 1 of RX Ring
	JNC	rcv_ovr_ng	;; >= NE_STOP_PG
				;;invalid pointer, Above the top
	MOV	next_packet,A	;save pointer to next packet
	MOV	curr_recv,R4	;save pointer to current packet
	setb	rx_eth_bit
	setb	eth_state1
	ret
;;	LCALL   ProcessEthPacket
;;	SJMP    rcv_ovr_ok
rcv_ovr_ng:
;
; HAD TO ADD ERROR RECOVERY HERE. TO BLINDLY PROCEED AND ASSUME THE NEXT
; PACKET POINTR FROM THE NIC HEADER IS VALID IS INVITING DISASTER.
;
; Error recovery consists of killing and restarting the NIC. This drops all
; the packets in the ring, but thats better than winding up in the weeds!
;

; Instead copy the last known current page pointer into the next packet pointer
; which will result in skipping all the packets from the errored one to where
; the NIC was storing them when we entered this ISR, but prevents us from
; trying to follow totally bogus next packet pointers through the card RAM
; space.
	MOV	A,R4		; Current memory page
	;;MOV	next_packet,A
	sjmp    recv_frame_break1	;save next_packet...

rcv_ovr_ok:
rcv_ovr_empty:
	MOV	A,next_packet	; Grap the next packet pointer
	DEC     A               ; Back up one page
	CJNE	A,#RX_START_PG,.+3 ;; Did it wrap?
	JNC	BoundaryOK	; >= RX_START_PG
	MOV	A,#NE_STOP_PG-1	;; Yes, back to end of ring
BoundaryOK:
	ISAOUTA	EN0_BOUNDARY	;Boundary Register
	BEGINPORTDATA
; Clear the OVW bit in the ISR register.
	PORTDATA	EN0_ISR, ENISR_OVER ;Interrupt status reg
				;Receiver overwrote the ring
; Take the NIC out of loopback
	PORTDATA	EN0_TXCR, 0	;Normal Operation
	ENDPORTDATA
; Any incomplete transmission to resend?
	JNB	flagResend,recv_frame_break	;No
; Yes, restart the transmission
	ISAOUT	EN_CMD, EN_TRANS+EN_NODMA+EN_START	;Start the transmitter
	sjmp   	recv_frame_break

recv_no_overrun:
	JNB	BITISR_COUNTERS, NoReadTallyCounters
;*************************
;*** ReadTallyCounters ***
;*************************
	PUSH	Acc
	MOV	ADDRPORT,#EN0_COUNTER0+I2CBUS	;CNTR0..2
;CNTR0 Frame Alignment Error Tally Counter Register
;CNTR1 CRC Error Tally Counter Register
;CNTR2 Missed Packet Tally Counter Register
	ISAREAD
	INC     ADDRPORT
	ISAREAD
	INC     ADDRPORT
	ISAREAD
	ISAOUT	EN0_ISR, #ENISR_COUNTERS	;Interrupt status reg
				;ReSet CNT (Error Tally Counters)
	POP	Acc
NoReadTallyCounters:
	JB	BITISR_RX, PacketReceivedOK
	JB	BITISR_RX_ERR, PacketReceived
	sjmp    recv_frame_break
PacketReceived:
PacketReceivedOK:
	ISAOUT	EN0_ISR, #ENISR_RX_ERR + ENISR_RX	; Clear those request
;; Get the rx page (incoming packet pointer)
	ISAOUT	EN_CMD, #EN_PAGE1+EN_NODMA+EN_START
				; Switch to page 1 registers
	ISAIN	EN1_CURPAG	; Get current page of rcv ring
	MOV	curpage, A	; ans save it
	ISAOUT	EN_CMD, #EN_PAGE0+EN_NODMA+EN_START
				; Back to page 0 registers
; This becomes the loop back point to read packets from the ring.
; now only loop back and read until those packets received at the time
; the current page register is read above have been read.
recv_frame:
;; Read all the frames ??
	MOV	R4,next_packet
	.using 0
	CJNE	A,AR4,recv_more_frames	; compare with saved
					; current page of rcv ring
	SJMP	recv_frame_break
;; Remove one frame from the ring. Boundary is always a page behind.
recv_more_frames:
	MOV	curr_recv,R4
;	MOV	R5,#0		; R4R5 Remote Start Address Register
	lcall   ReadPacketHeader
	MOV	A,rcv_hdr	; Get the buffer status byte
	XRL	A,#ENRSR_RXOK	; Good packet ?
	JZ	GoodPacket
	XRL	A,#((ENRSR_PHY + ENRSR_RXOK) ^ ENRSR_RXOK)
				;Received broadcast/multicast
	JNZ	InvalidNextFramePtr
GoodPacket:
; EVEN if the NIC header status is OK, I have seen garbaged NIC headers, so
; it doesn't hurt to range check the next packet pointer here.
	MOV	A,rcv_hdr_nxt_pg; get pointer to next packet
	MOV	next_packet,A	; and save it
	CJNE	A,#RX_START_PG,.+3	;; First page of RX Ring
	JC	InvalidNextFramePtr	; < RX_START_PG
	CJNE	A,#NE_STOP_PG,.+3	;; Last page + 1 of RX Ring
	JC	ProcessFrame		; next_packet < NE_STOP_PG
;
InvalidNextFramePtr:
	MOV	A, curpage	; Get current page of rcv ring
recv_frame_break1:
	MOV	next_packet,A
recv_frame_break:
	ISAOUT	EN0_ISR, #ENISR_RDC ;Interrupt status reg
				;remote dma complete
	RET

ProcessFrame:
	setb	rx_eth_bit
	setb	eth_state2
;;	LCALL   ProcessEthPacket
	ret
eth2state:
	MOV	R4,next_packet
	DEC     R4
	CJNE	R4,#RX_START_PG,.+3	;;First page of RX Ring
	JNC	SetBoundaryNxt	; >= RX_START_PG
	MOV	R4,#NE_STOP_PG-1;;Last page + 1 of RX Ring
SetBoundaryNxt:
	ISAOUT	EN0_BOUNDARY,R4	; Boundary page of ring buffer
	MOV	A, curpage	; Get current page of rcv ring
	SJMP    recv_frame
;*************************************************************
;
send_port:
	PUSH	ACC
	MOV	A,R0
	PUSH	ACC
	MOV	R0,SP
	PUSH	DPL
	PUSH	DPH
	DEC	R0
	DEC	R0
	MOV	DPH,@R0         ;get string address
	DEC	R0		;from stack
	MOV	DPL,@R0
Sport0:	CLR	A
	MOVC	A,@A+DPTR  	;get port address
	CJNE	A,#endport,Sport1	;print it
	INC	DPTR		;end of string
	MOV	@R0,DPL		;change return address on stack
	INC	R0
	MOV	@R0,DPH
	POP	DPH		;restore DPH
	POP	DPL		;restore DPL
	POP	ACC
	MOV	R0,A
	POP	ACC
	RET
;
Sport1:
	MOV	C,Acc.5
	ORL	A,#I2CBUS
	MOV	ADDRPORT,A
	INC	DPTR
	CLR	A
	MOVC	A,@A+DPTR  	;get port data
	JNC	NoSpInd
	.using 0
	PUSH	AR0
	MOV	R0,A
	MOV	A,@R0
	POP	AR0
NoSpInd:
.if MOVXMODE
	MOVX	@R0,A
.else
	MOV	P0,A
	CLR	P3.6
	NOP
	SETB	P3.6
.endif
	INC	DPTR
	SJMP	Sport0

	.section reset_network, #alloc
	LCALL	network_init

	;; END
