; Serial Communication Library (c)Copyright 2000, Radek Benedikt
;	benedikt@lphard.cz, http://benedikt.lphard.cz

; History: 1.00 -- Radek Benedikt 31-Oct-2000
;  initial version
;*************************************************************
;***		PROJECT WWW8052  http://8052.lphard.cz	    **
;*************************************************************

;   This program is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, version 2.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the Free Software
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;   Tento program je volne programove vybaveni; muzete jej sirit a
;   modifikovat podle ustanoveni Obecne verejne licence GNU, vydavane Free
;   Software Foundation, verze 2
;
;   Tento program je rozsirovan v nadeji, ze bude uzitecny, avsak BEZ
;   JAKEKOLI ZARUKY; neposkytuji se ani odvozene zaruky PRODEJNOSTI anebo
;   VHODNOSTI PRO URCITY UCEL.
;   Dalsi podrobnosti hledejte v Obecne verejne licenci GNU.
;
;   Kopii Obecne verejne licence GNU jste mel obdrzet spolu s timto
;   programem; pokud se tak nestalo, napiste o ni Free Software Foundation,
;   Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
	.global	getchar
	.global	xputchar
	.global	pchar
	.global	putchar
	.global	sstat
	.global	intRITI

	.global	rxint
	.global	txint
	.global	srun
	.global	rtscts
	.global	xonxoff
	.global	flagxoff
	.global	xonrq
	.global	xoffrq
	.global	flagtxoff
	.global	r1point
	.global	s1point
	.global	sser
	.global	rser
;extrn	BIT(cflag)
;
.nolist
.include "../include/param.inc"
.list
;
	.equ	EEMEN, 0b00001000
	.equ	XON, 0x11
	.equ	XOFF,0x13

	.bitcomm rxint, 1
	.bitcomm txint, 1
	.bitcomm srun, 1
	.bitcomm rtscts, 1
	.bitcomm xonxoff, 1
	.bitcomm flagxoff, 1
	.bitcomm xonrq, 1
	.bitcomm xoffrq, 1
	.bitcomm flagtxoff, 1

	.comm	r1point, 1	;receive serial buffer - pointer 1
	.comm	s1point, 1	;send serial buffer - pointer 1

; send buffer
	.icomm	sser, lngsser	;send serial buffer - 0Dxh
; receive buffer
	.icomm	rser, lngrser	;receive serial buffer - 0Exh

	.text
;
;#########################################################
;  Procedura cteni znaku za serioveho kanalu
;#########################################################
;
getchar:jnb	rxint,retchar	;idioten sichr
	mov	r0,#rser
	MOV	A,@r0		;precti znak
	mov	r1,a
	mov	r0,#LOW(rser+lngrser)
	CLR	ES		;disable serial interrupt
fllp:	dec	r0
	xch	a,@r0
	cjne	r0,#rser,fllp
	dec	r1point
	mov	a,r1point
	cjne	a,#(rser+MAXCHAR),.+3
	cpl	C		;if v bufferu je > MAXCHAR znaku then reset RTS/
	jnb	rtscts,getchar1
	mov	RTS,C
getchar1:
	jnb	xonxoff,getchar2
	jc	getchar2		;XOFF
	jnb	flagxoff,getchar2	;O.K.
	jb	srun,getchr2		;nezahajuj vysilani, vysila se
	clr	flagxoff
	mov	SBUF,#XON		;vysli XON
	setb	srun
	sjmp	getchar2
getchr2:setb	xonrq			;XON request
getchar2:cjne	a,#rser,notempty
	clr	rxint			;buffer empty clear "NoEmpty flag"
notempty:SETB	ES			;enable serial interrupt
	mov	a,r1
retchar:ret

;
;#########################################################
;
;testbuffer:
;	mov	C,rxint
;	mov	cflag,C
;	ret
;
;#########################################################
;  Procedura zapis znaku do serioveho kanalu
;#########################################################
;
	.using	0
xputchar:
	push	Acc
	MOV	a,s1point
	xrl	a,#sser+lngsser
	jnz	xptchr		;neni plno, vysli znak
	djnz	acc,.
	MOV	a,s1point	;1th retry
	xrl	a,#sser+lngsser
	jnz	xptchr		;neni plno, vysli znak
	djnz	acc,.
	MOV	a,s1point	;2nd retry
	xrl	a,#sser+lngsser
	jnz	xptchr		;neni plno, vysli znak
	pop	Acc
	clr	A		;0 char send
	ret
pchar:
	mov	a,R7
putchar:
	push	Acc
ptchr:
	MOV	a,s1point
	xrl	a,#sser+lngsser
	jz	ptchr		;je plno cekej na uvolneni
xptchr:	pop	Acc
	push	ar0
	CLR	ES		;disable serial interrupt
	mov	r0,s1point
	MOV	@r0,A		;uloz znak do bufferu
	inc	s1point
	SETB	ES		;enable serial interrupt
	pop	ar0
	jnb	rtscts, ptchr1
	jb	CTS,ptchrr	;nezahajuj pripadne vysilani
ptchr1:	jnb	xonxoff,ptchr2
	jb	flagtxoff, ptchrr ;nezahajuj pripadne vysilani
ptchr2:	jb	srun,ptchrr
	setb	TI
	setb	srun
ptchrr:	mov	a,#1		;1 char send
	ret
;
;#########################################################
;  Procedura zahajeni vysilani znaku do serioveho kanalu
;            a vypoctu delky vysilaci fronty
;#########################################################
;
sstat:	CLR	ES		;disable serial interrupt
	jb	xonrq,sstat2
	jb	xoffrq,sstat2
	MOV	a,s1point	;spocitej pocet znaku v bufferu
	xrl	A,#sser
	jz	sstatexit 	;neni co vysilat
	jnb	rtscts,sstat1
	jb	CTS,sstatexit	;nezahajuj vysilani, obsazeno
sstat1:	jnb	xonxoff,sstat2
	jb	flagtxoff,sstatexit	;nezahajuj vysilani, obsazeno
sstat2:	jb	srun,sstatexit	;nezahajuj vysilani, vysila se
	setb	TI
	setb	srun
sstatexit:
	SETB	ES		;enable serial interrupt
	ret
;
;#########################################################
;  Procedura Preruseni od prijateho znaku
;#########################################################
;
intRITI:JBC	RI,INT_READ	;je preruseni od prijimace
	JBC	TI,INT_WRITE	;je preruseni od vysilace
	RETI
INT_WRITE:
	PUSH	PSW
	PUSH	ACC
	PUSH	AR0
	setb	txint		;nastav priznak preruseni od vyslaneho znaku
	jnb	xoffrq, int_w1
	clr	xoffrq
	setb	flagxoff
	MOV	SBUF,#XOFF	;vysli XOFF
	sjmp	INT_WRITE_END
int_w1:	jnb	xonrq, int_w2
	clr	xonrq
	clr	flagxoff
	MOV	SBUF,#XON	;vysli XON
	sjmp	INT_WRITE_END
int_w2:	mov	a,s1point	;send serial buffer - pointer 1
	xrl	a,#sser
	clr	srun
	jz	INT_WRITE_END	;neni co vysilat
	jnb	rtscts, int_w3
	jb	CTS,INT_WRITE_END ;nezahajuj pripadne vysilani
int_w3:	jnb	xonxoff,int_w4
	jb	flagtxoff,INT_WRITE_END ;nezahajuj pripadne vysilani
int_w4:	mov	r0,#sser
	MOV	A,@r0		;vyjmi data z bufferu
	MOV	SBUF,A		;vysli znak
	setb	srun
	mov	r0,#LOW(sser+lngsser)
flls:	dec	r0
	xch	a,@r0
	cjne	r0,#sser,flls
	dec	s1point		;dec send serial buffer pointer
INT_WRITE_END:
	POP	AR0
	POP	ACC
	POP	PSW
	RETI
;
INT_READ:
	PUSH	PSW
	PUSH	ACC
	PUSH	AR0
	setb	rxint		;nastav priznak preruseni od prijateho znaku
	mov	a,r1point	;receive serial buffer
	mov	r0,a
	xrl	a,#LOW(rser+lngrser)
	jz	INT_READ_END
	MOV	A,SBUF		;precti znak
	jnb	xonxoff,int_r0
	cjne	A,#XON,noXON
	clr	flagtxoff
	sjmp	int_r2
noXON:	cjne	A,#XOFF,int_r0
	setb	flagtxoff
	sjmp	int_r2
int_r0:	MOV	@r0,A		;uloz data do bufferu
	inc	r1point
	mov	a,r1point
	cjne	a,#(rser+MAXCHAR),.+3
	cpl	C		;if v bufferu je > MAXCHAR znaku then reset RTS/
	jnb	rtscts,int_r1
	mov	RTS,C
int_r1: jnb	xonxoff,int_r2
	jnc	int_r2		;XON request
	jb	flagxoff,int_r2	;O.K.
	jb	srun,intr2	;nezahajuj vysilani, vysila se
	setb	flagxoff
	mov	SBUF,#XOFF	;vysli XOFF
	setb	srun
	sjmp	int_r2
intr2:	setb	xoffrq		;XOFF request
int_r2:	POP	AR0
	POP	ACC
	POP	PSW
	RETI

INT_READ_END:
	MOV	A,SBUF		;neni misto precti znak a zahod ho
	jnb	xonxoff,int_r2
	cjne	A,#XON,no_XON
	clr	flagtxoff
	sjmp	int_r2
no_XON:	cjne	A,#XOFF,int_r2
	setb	flagtxoff
	sjmp	int_r2
;
	.section reset_device, #alloc
init_serial:
	orl	PCON,#0x80
	mov	SCON,#0x52
	orl     TMOD,#0b00100000 ;timer 1, autoreload 8 bit
	mov	WMCON,#(WATCHDOG | EEMEN);enable EEPROM
	mov	dptr,#flash_flow
	movx	a,@dptr
	mov	C,B2B(ACC,optrtscts)
	mov	rtscts,C
	mov	C,B2B(ACC,optxonxoff)
	mov	xonxoff,C
	mov	dptr,#flash_baud
	movx	a,@dptr
	mov	WMCON,#WATCHDOG		;disable EEPROM
	MOV	TH1,a
	MOV	TL1,a
	orl	TCON,#0xC0      ;start timer1
	mov	r1point,#rser	;receive serial buffer - pointer 1
	mov	s1point,#sser	;send serial buffer - pointer 1
	jnb	rtscts, init_ser1
	clr	RTS		;povol prijem
	mov	SBUF,#0
init_ser1:
	jnb	xonxoff, init_ser2
	clr	flagtxoff
	clr	xoffrq
	clr	xonrq
	mov	SBUF,#XON	;direct send XON
	setb	srun
init_ser2:
	setb	TR1
	orl	IE,#0b00010000	; enable serial port interrupt
;
	;; END

