.nolist
.include	"../../include/param.inc"
.include	"../../include/8019.inc"
.list
.if (MAGIC ^ VERSION)
    .print "Invalid ACTIVESTACK/DUALSTACK/SERIAL setings"
    .err
.endif
.include	"ether.inc"
.include	"ip.inc"

; "http"
	.global	STACK1MODE
	.equ	STACK1MODE, NORESENDMODE
	.global	ETHRETRY1
	.equ	ETHRETRY1,  5*2		; timeout = 2 s
	.global PORT1			; local port
	.equ	PORT1, 80

	.text

	.global open_stack1
	.global process_stack1
	.global close_stack1

open_stack1:	ljmp	open_http
process_stack1:	ljmp	http
close_stack1:	ret

	.rdata
.global	data_addr
.global	data_len
.global	unwrited
.global	mac_gateway
.global	state80
data_addr:	.ds	1	;start of data in TCP packet
data_len:	.ds	1	;length of data in TCP packet
unwrited:	.ds	1	;unwrited data length
mac_gateway:	.ds	3
state80:	.ds.b	1
;
;PCODE DATA
.global	chkacc, chklen, chkaddr
.global	pcodeMSB, pcodeLSB
chkacc:		.ds	1
chklen:		.ds	1
chkaddr:	.ds	1
pcodeMSB:	.ds.b	1
pcodeLSB:	.ds.b	1
.global	LEDmode
LEDmode:	.ds.b	1
flashtimer:	.ds.b	1
;
;#########################################################
;  Main Loop
;#########################################################
;
	.section fast, #alloc
;*************************************************************
	mov	a,LEDmode
	jb	Acc.1,nosetL0	;Flash LED0
	mov	C,Acc.0
	cpl	C
	mov	LED0,C
nosetL0:
	jb	Acc.3,nosetL1	;Flash LED1
	mov	C,Acc.2
	cpl	C
	mov	LED1,C
nosetL1:

	.section slow, #alloc
;*************************************************************
;~50 ms loop
	dec	flashtimer
	setb	LED0		;enable readout keyboard
	setb	LED1
;unpack packed bit array
	mov	a,LEDmode
	anl	a,#0b00000011	;LED0
	mov	R4,a
	mov	a,LEDmode
	anl	a,#0b00001100	;LED1
	mov	R5,a
	mov	a,LEDmode
	anl	a,#0b00110000	;KBD0
	mov	R6,a
	mov	a,LEDmode
	anl	a,#0b11000000	;KBD1
	mov	R7,a
	mov	C,LED1
	mov	Acc.5,C
	cjne	a,#0b10000000,NCH1	;test KBD1 change 1->0
	mov	R7,#0b00000000
	mov	a,R5
	add	a,#0b00000100
	jb	P,no11L1		;jmp if 00000100 or 00001000
	clr	a			;00001100 -> 00000000
no11L1:	mov	R5,a
	sjmp	tstL0
NCH1:	rl	a
	anl	a,#0b11000000
	mov	R7,a
tstL0:	mov	a,R6
	mov	C,LED0
	mov	Acc.3,C
	cjne	a,#0b00100000,NCH0	;test KBD1 change 1->0
	mov	R6,#0b00000000
	mov	a,R4
	add	a,#0b00000001
	jb	P,no11L0		;jmp if 00000001 or 00000010
	clr	a			;00000011 -> 00000000
no11L0:	mov	R4,a
	sjmp	packarr
NCH0:	rl	a
	anl	a,#0b00110000
	mov	R6,a
packarr:mov	a,R4
	orl	a,R5
	orl	a,R6
	orl	a,R7
	mov	LEDmode,a
	jnb	Acc.1,noFl0	;Flash LED0
	mov	a,flashtimer
	mov	C,Acc.4
	mov	LED0,C
	mov	a,LEDmode
noFl0:	
	jnb	Acc.3,noFl1	;Flash LED1
	mov	a,flashtimer
	mov	C,Acc.4
	mov	LED1,C
noFl1:

	.section reset_device, #alloc
;*************************************************************

	;; END
