	.equ	DPH1,  0x85
	.equ	DPL1,  0x84
	.equ	WMCON, 0x96
	.equ	DPS,   0b00000100
	.equ	EEMEN, 0b00001000
	.equ	EEMWE, 0b00010000
	.equ	F0, 0xD5

.nolist
.include	"../../include/param.inc"
.include	"../../include/8019.inc"
.list

	.section cpu_dir, #alloc

	.word	'i'+'p'+'s'+'e'+'t'+'u'+'p'+'.'+'c'+'g'+'i'
	.byte	0x10		;cgi
	.byte	0		;reserved
	.word	cgibegin
	.word	cgiend

	.section cpu_files, #alloc

cgibegin:		;ipsetup.cgi
	.pcode ipsetup
	.pcode pret
cgiend:

	.global	ipsetup

	.text
	.using	0

;; ipsetup
;;   return
;; O.K. - set   zflag
;; fail - reset zflag

ipsetup:jnb	flagSecure,noExecCgi
	mov	state80,#'I'	; find IP address
	lcall	scanpar
	jnb	zflag, noIcmd
	;; cmdI
	mov	dptr,#new_my_ip
	lcall	read_IP_param
noIcmd:	mov	state80,#'M'	; find IP mask
	lcall	scanpar
	jnb	zflag, noMcmd
	;; cmdM
	mov	dptr,#new_ip_mask
	lcall	read_IP_param
noMcmd:	mov	state80,#'G'	; find IP gateway
	lcall	scanpar
	jnb	zflag, noGcmd
	;; cmdG
	mov	dptr,#new_ip_gateway
	lcall	read_IP_param
noGcmd:	mov	state80,#'T'	; find IP point
	lcall	scanpar
	jnb	zflag, noTcmd
	;; cmdT
	mov	dptr,#new_ip_point
	lcall	read_IP_param
noTcmd:	mov	state80,#'P'	; find protocol
	lcall	scanpar
	jnb	zflag, noPcmd
	;; cmdP
	mov	dptr,#new_flow
	lcall	read_dec_param
noPcmd:	mov	state80,#'B'	; find Baud
	lcall	scanpar
	jnb	zflag, noBcmd
	;; cmdB
	mov	a,@r0
	add	a,#-'1'
	cjne	a,#8,.+3	;'1'..'8'
	jc	L1

process_param_error:
noExecCgi:
	;error return - unattended char / missing password
	clr	zflag
	ret

L1:	mov	R1,a
	inc	R1	;1..8
	clr	A
	setb	C
bdlp:	rlc	A
	djnz	R1,bdlp
	mov	b,#LOW(CPUCLOCK/384)
	mul	ab
	cpl	a
	inc	a
	mov	R1,a
	mov	dptr,#new_baud
	lcall	writeparam
noBcmd:	jbc	F0, noEcmd
	mov	state80,#'E'	; find copy cmd
	lcall	scanpar
	jnb	zflag, noEcmd
	;; cmdE
	mov	a,@R0
	cjne	a,#'N',nonewconfig
	mov	dptr,#new_setup
moveconfig:
	mov	DPH1,#HIGH(work_setup)
	mov	DPL1,#LOW(work_setup)
	mov	R0,#sizeof_new_setup
moveconfigloop:
	mov	WMCON,#(WATCHDOG | EEMEN) ;enable EEPROM
	movx	a,@dptr
	mov	R1,a
	inc	dptr
	mov	WMCON,#(WATCHDOG | EEMEN | EEMWE | DPS) ;enable R/W EEPROM & DPTR'
	lcall	writeee
	djnz	R0,moveconfigloop
	setb	F0		;  skip one "config" copy cmd (if not IE make newerending loop)
	ljmp	reset
nonewconfig:
	cjne	a,#'D',process_param_error
	mov	dptr,#default_setup
	sjmp	moveconfig

noEcmd:
	setb	zflag
	ret

read_IP_param:
	lcall	read_dec_param		;@ 1 byte
	mov	a,@r0
	cjne	a,#'.',process_param_error
	lcall	read_dec_inc_r0		;@ 2 byte
	mov	a,@r0
	cjne	a,#'.',process_param_error
	lcall	read_dec_inc_r0		;@ 3 byte
	mov	a,@r0
	cjne	a,#'.',process_param_error
;	ljmp	read_dec_inc_r0		;@ 4 byte
read_dec_inc_r0:
	inc	r0
read_dec_param:
	mov	r1,#0
read_decb_loop:
	mov	a,@r0
	add	a,#-'0'
	cjne	a,#9+1,.+3
	jnc	writeparam
	xch	a,r1
	mov	B,#10
	mul	ab
	add	a,r1
	mov	r1,a
	inc	r0
	sjmp	read_decb_loop
writeparam:
	mov	WMCON,#(WATCHDOG | EEMEN | EEMWE) ;enable R/W EEPROM
writeee:
	movx	a,@dptr		;read eeprom
	xrl	a,R1
	jz	nowrpar		;no need change, bypas write
	mov	a,R1
	movx	@dptr,a		;write
waitpar:movx	a,@dptr		;wait for end of write
	cjne	A,AR1,waitpar
nowrpar:inc	dptr
	mov	WMCON,#WATCHDOG		;disable EEPROM
	clr	C
	ret	;ret NC
	;; END

